<?php
   // Modified version of pipho to generate offline JAIPHO slide show
   // Revision by Peter Jennings http://benlo.com/jaipho
   // Licensed under LGPL
   
	// INCLUDE PATH
	set_include_path(
		'library' . PATH_SEPARATOR .
		get_include_path());
	
	// PIPHO VALUES
	define('PIPHO_PHOTOS_FOLDER', 'photos');	
	define('PIPHO_FORCE_WRITE', false);	
	
	define('PIPHO_SLIDE_RESIZE_ENABLED', true);
	
	define('PIPHO_SORT_GALLERIES_ENABLED', true);
	define('PIPHO_SORT_GALLERIES_SORT_TYPE', SORT_REGULAR);	
	define('PIPHO_SORT_GALLERIES_REVERSE', false);
	
	define('PIPHO_SORT_IMAGES_ENABLED', true);
	define('PIPHO_SORT_IMAGES_SORT_TYPE', SORT_REGULAR);	
	define('PIPHO_SORT_IMAGES_REVERSE', false);
	
	
	require_once 'Pipho/DeviceInfo.php';
	require_once 'Pipho/FileManager.php';


   if ( !isset( $_GET['gallery_id']) )
   {
   echo "<html><head><meta name=\"viewport\" content=\"width=device-width; initial-scale=1.0; maximum-scale=1.0; user-scalable=0;\"/></head><body>";
   echo "<h3>Build Offline Slide Show for iPhone or iPod Touch</h3>";
   echo "1. Create a new folder full of photos like " . getcwd() . "/photos/test<br /><p>"; 
   echo "2. Enter the name of the folder below and press the button.";
   echo "<form action=\"build_app.php\" method=\"get\">\n";
   echo "Photo folder: <input type=\"text\" value=\"test\" name=\"gallery_id\">\n";
   echo "<input type=\"submit\" value=\"Build Offline Show\"></form>\n</body></html>";

   exit;
   }
	$gallery_id		=	isset( $_GET['gallery_id']) ? $_GET['gallery_id'] : 'test';
	
	
	
	$device_info	=	Pipho_DeviceInfo::getDeviceInfo();
	
	try
	{
		$pipho			=	new Pipho_FileManager( $device_info, PIPHO_PHOTOS_FOLDER, PIPHO_FORCE_WRITE);
		$pipho->init();
		
		$gallery		=	$pipho->getGallery( $gallery_id);
		$images		=	$pipho->getGalleryImages( $gallery_id);
		
		$html = file_get_contents('html.template');
      $html = str_replace( '%gallery->title%', $gallery->title, $html );

		$manifest = "CACHE MANIFEST\n\n# Offline cache v1\n\n";
      $manifest .= "$gallery->id.html\n";
		$handle = opendir("jaipho");

		while($filename = readdir($handle)) 
		   {
		   if ( strpos($filename, ".png") || strpos($filename, ".css") || strpos($filename, ".js") || strpos($filename, ".gif")  )
		      {
		      $manifest .= "jaipho/$filename\n";
				}
		   }
		closedir($handle);
      
		$daoImageList = '';
		foreach ($images as $image)
		{
			$daoImageList .= $image->getJsReadImage();	
			
			$manifest .=  $image->urlSlide . "\n";
			$manifest .=  $image->urlThumb . "\n";
		}
      $html = str_replace( "%daoImageList%", $daoImageList, $html );
      $html = str_replace( "%gallery->id%", $gallery->id, $html );
		
      file_put_contents("$gallery->id.html", $html );
		file_put_contents("$gallery->id.manifest", $manifest );
	}
	catch (Exception $e)
	{
		die( $e->getMessage());
	}
	
?>	
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8"/>
<meta http-equiv="cache-control" content="no-cache"/>

<meta name="viewport" content="width=device-width; initial-scale=1.0; maximum-scale=1.0; user-scalable=0;"/>
	
<title>Build Offline JAIPHO Slide Show</title>

	<!-- 
		JAIPHO - iPhone optimized javascript gallery
		Check on http://www.jaipho.com/ for latest news and source updates 
	 -->
</head>


<body>
<h3>Build Offline Slide Show for iPhone or iPod Touch</h3>
<p>
<b>build_app</b> run complete.<br />
<p>
<?php	echo "Open <a href=\"$gallery->id.html\">$gallery->id.html</a> on your iPhone.<br />";
      echo "Wait for it to finish loading.<br />Choose the photo you want as an icon.<br />Bookmark it to the Home Screen.";  ?>
<br />
<p>
Note: To delete the offline app, delete the icon from the Home Screen and reboot the iPhone.
</body>
</html>
	